/************************************************************************
 * This file is part of AdminCmd.									
 *																		
 * AdminCmd is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by	
 * the Free Software Foundation, either version 3 of the License, or		
 * (at your option) any later version.									
 *																		
 * AdminCmd is distributed in the hope that it will be useful,	
 * but WITHOUT ANY WARRANTY; without even the implied warranty of		
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			
 * GNU General Public License for more details.							
 *																		
 * You should have received a copy of the GNU General Public License
 * along with AdminCmd.  If not, see <http://www.gnu.org/licenses/>.
 ************************************************************************/
package be.Balor.Listeners.Features;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerChangedWorldEvent;

import be.Balor.Manager.LocaleManager;
import be.Balor.Manager.Permissions.PermissionManager;
import be.Balor.Player.ACPlayer;

/**
 * @author Balor (aka Antoine Aflalo)
 * 
 */
public class ACResetPowerListener implements Listener {
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerChangedWorld(final PlayerChangedWorldEvent event) {
		final Player bPlayer = event.getPlayer();
		if (PermissionManager.hasPerm(bPlayer, "admincmd.player.noreset", false)) {
			return;
		}
		final ACPlayer player = ACPlayer.getPlayer(bPlayer);
		if (!player.removeAllSuperPower().isEmpty()) {
			LocaleManager.sI18n(bPlayer, "changedWorld");
		}

	}
}
